import { getNextElement as f, getNextMarker as b, insert as p, createComponent as l, effect as ne, setAttribute as be, runHydrationEvents as se, delegateEvents as ve, template as m, use as ye, memo as Ge, spread as Je, mergeProps as et, hydrate as tt, render as nt } from "solid-js/web";
import { createSignal as B, onMount as $e, onCleanup as rt, For as ot, Show as x, createEffect as it, createContext as at, useContext as st } from "solid-js";
import { Compartment as we, SelectionRange as lt, EditorSelection as dt, RangeSetBuilder as _e, Transaction as ct, EditorState as ut } from "@codemirror/state";
import { markdown as ft, markdownLanguage as mt } from "@codemirror/lang-markdown";
import { languages as pt } from "@codemirror/language-data";
import { EditorView as q, Decoration as L, ViewPlugin as Ce, keymap as gt } from "@codemirror/view";
import { syntaxTree as le, syntaxHighlighting as kt, HighlightStyle as ht } from "@codemirror/language";
import { defaultKeymap as bt, historyKeymap as xt, indentMore as vt, indentLess as yt, history as $t } from "@codemirror/commands";
import { tags as c } from "@lezer/highlight";
const wt = "data-ink-mde-ssr-hydration-marker", _t = `[${wt}]`, Ct = () => ({}), E = {
  array: "[object Array]",
  object: "[object Object]",
  string: "[object String]",
  undefined: "[object Undefined]",
  window: "[object Window]"
}, St = (e) => {
  if (Object.prototype.toString.call(e) === E.object)
    return `[object ${e.constructor.name}]`;
}, T = (e, t) => St(e) === t, Lt = (e, t) => {
  const n = /* @__PURE__ */ new WeakMap(), r = (o, i) => n.get(o) || (T(o, E.object) && n.set(o, !0), T(i, E.undefined)) ? o : T(o, E.array) && T(i, E.array) ? [...i] : T(o, E.object) && T(i, E.object) ? Object.keys(o).reduce((a, s) => (Object.hasOwnProperty.call(i, s) ? a[s] = r(o[s], i[s]) : a[s] = o[s], a), {}) : i;
  return r(e, t);
}, P = (e, t) => Lt(e, t);
var V = /* @__PURE__ */ ((e) => (e.Auto = "auto", e.Dark = "dark", e.Light = "light", e))(V || {}), Mt = /* @__PURE__ */ ((e) => (e.Appearance = "appearance", e.Attribution = "attribution", e.Autocomplete = "autocomplete", e.Images = "images", e.ReadOnly = "readonly", e.Spellcheck = "spellcheck", e.Vim = "vim", e))(Mt || {}), k = /* @__PURE__ */ ((e) => (e.Bold = "bold", e.Code = "code", e.CodeBlock = "code_block", e.Heading = "heading", e.Image = "image", e.Italic = "italic", e.Link = "link", e.List = "list", e.OrderedList = "ordered_list", e.Quote = "quote", e.TaskList = "task_list", e))(k || {}), Y = /* @__PURE__ */ ((e) => (e.Completion = "completion", e.Default = "default", e.Grammar = "grammar", e.Language = "language", e))(Y || {}), re = /* @__PURE__ */ ((e) => (e.End = "end", e.Start = "start", e))(re || {});
const xe = () => document.createElement("div"), Se = () => window.matchMedia("(prefers-color-scheme: dark)").matches, Ht = (e) => e === V.Dark ? !0 : e === V.Light ? !1 : Se(), te = (e) => {
  const t = [
    // --ink-*
    { suffix: "border-radius", default: "0.25rem" },
    { suffix: "color", default: "currentColor" },
    { suffix: "flex-direction", default: "column" },
    { suffix: "font-family", default: "inherit" },
    // --ink-block-*
    { suffix: "block-background-color", default: "#121212", light: "#f5f5f5" },
    { suffix: "block-background-color-on-hover", default: "#0f0f0f", light: "#e0e0e0" },
    { suffix: "block-max-height", default: "20rem" },
    { suffix: "block-padding", default: "0.5rem" },
    // --ink-code-*
    { suffix: "code-background-color", default: "var(--ink-internal-block-background-color)" },
    { suffix: "code-color", default: "inherit" },
    { suffix: "code-font-family", default: "'Monaco', Courier, monospace" },
    // --ink-editor-*
    { suffix: "editor-font-size", default: "1em" },
    { suffix: "editor-line-height", default: "2em" },
    { suffix: "editor-padding", default: "0.5rem" },
    { suffix: "inline-padding", default: "0.125rem" },
    // --ink-modal-*
    { suffix: "modal-position", default: "fixed" },
    // --ink-syntax-*
    { suffix: "syntax-atom-color", default: "#d19a66" },
    { suffix: "syntax-comment-color", default: "#abb2bf" },
    { suffix: "syntax-comment-font-style", default: "italic" },
    { suffix: "syntax-emphasis-color", default: "inherit" },
    { suffix: "syntax-emphasis-font-style", default: "italic" },
    { suffix: "syntax-hashtag-background-color", default: "#222", light: "#eee" },
    { suffix: "syntax-hashtag-color", default: "inherit" },
    { suffix: "syntax-heading-color", default: "inherit" },
    { suffix: "syntax-heading-font-weight", default: "600" },
    { suffix: "syntax-heading1-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading1-font-size", default: "1.6em" },
    { suffix: "syntax-heading1-font-weight", default: "600" },
    { suffix: "syntax-heading2-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading2-font-size", default: "1.5em" },
    { suffix: "syntax-heading2-font-weight", default: "600" },
    { suffix: "syntax-heading3-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading3-font-size", default: "1.4em" },
    { suffix: "syntax-heading3-font-weight", default: "600" },
    { suffix: "syntax-heading4-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading4-font-size", default: "1.3em" },
    { suffix: "syntax-heading4-font-weight", default: "600" },
    { suffix: "syntax-heading5-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading5-font-size", default: "1.2em" },
    { suffix: "syntax-heading5-font-weight", default: "600" },
    { suffix: "syntax-heading6-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading6-font-size", default: "1.1em" },
    { suffix: "syntax-heading6-font-weight", default: "600" },
    { suffix: "syntax-highlight-background-color", default: "#555555" },
    { suffix: "syntax-keyword-color", default: "#c678dd" },
    { suffix: "syntax-link-color", default: "inherit" },
    { suffix: "syntax-meta-color", default: "#abb2bf" },
    { suffix: "syntax-monospace-color", default: "var(--ink-internal-code-color)" },
    { suffix: "syntax-monospace-font-family", default: "var(--ink-internal-code-font-family)" },
    { suffix: "syntax-name-color", default: "#d19a66" },
    { suffix: "syntax-name-label-color", default: "#abb2bf" },
    { suffix: "syntax-name-property-color", default: "#96c0d8" },
    { suffix: "syntax-name-property-definition-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-definition-color", default: "#e5c07b" },
    { suffix: "syntax-name-variable-local-color", default: "#d19a66" },
    { suffix: "syntax-name-variable-special-color", default: "inherit" },
    { suffix: "syntax-number-color", default: "#d19a66" },
    { suffix: "syntax-operator-color", default: "#96c0d8" },
    { suffix: "syntax-processing-instruction-color", default: "#444444", light: "#bbbbbb" },
    { suffix: "syntax-punctuation-color", default: "#abb2bf" },
    { suffix: "syntax-strikethrough-color", default: "inherit" },
    { suffix: "syntax-strikethrough-text-decoration", default: "line-through" },
    { suffix: "syntax-string-color", default: "#98c379" },
    { suffix: "syntax-string-special-color", default: "inherit" },
    { suffix: "syntax-strong-color", default: "inherit" },
    { suffix: "syntax-strong-font-weight", default: "600" },
    { suffix: "syntax-url-color", default: "#aaaaaa", light: "#666666" }
  ], n = !Ht(e.options.interface.appearance);
  return t.map((r) => {
    const o = n && r.light ? r.light : r.default;
    return `--ink-internal-${r.suffix}: var(--ink-${r.suffix}, ${o});`;
  });
}, At = (e) => [
  q.theme({}, { dark: e })
], zt = (e) => e.extensions.map((t) => t.initialValue(e)), de = (e) => Promise.all(
  e.extensions.map((t) => t.reconfigure(e.options))
), Et = (e) => {
  const t = new we();
  return {
    compartment: t,
    initialValue: (n) => t.of(e(n.options)),
    reconfigure: (n) => t.reconfigure(e(n))
  };
}, Bt = (e) => {
  const t = new we();
  return {
    compartment: t,
    initialValue: (n) => t.of([]),
    reconfigure: (n) => e(n, t)
  };
}, jt = () => [
  ...Dt.map((e) => Et(e)),
  ...Tt.map((e) => Bt(e))
], Dt = [
  (e) => e.plugins.reduce((n, r) => (r.type === Y.Default && n.push(r.value), n), []),
  (e) => {
    const t = e.plugins.reduce((r, o) => (o.type === Y.Grammar && r.push(o.value), r), []), n = e.plugins.reduce((r, o) => (o.type === Y.Language && r.push(o.value), r), []);
    return ft({
      base: mt,
      codeLanguages: [...pt, ...n],
      extensions: t
    });
  },
  (e) => {
    const t = e.interface.appearance === V.Dark, n = e.interface.appearance === V.Auto;
    return At(t || n && Se());
  }
], Tt = [
  async (e, t) => {
    if (e.interface.autocomplete) {
      const { autocomplete: n } = await import("./autocomplete-294208a2.js");
      return t.reconfigure(n(e));
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.images) {
      const { images: n } = await import("./images-1efb4104.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.lists) {
      const { lists: n } = await import("./lists-45709764.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.placeholder) {
      const { placeholder: n } = await import("./placeholder-985d86f2.js");
      return t.reconfigure(n(e.placeholder));
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.readonly) {
      const { readonly: n } = await import("./readonly-28fcecea.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.spellcheck) {
      const { spellcheck: n } = await import("./spellcheck-9deeebb9.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.vim) {
      const { vim: n } = await import("./vim-96332d1a.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  }
], oe = () => {
  const e = {
    doc: "",
    files: {
      clipboard: !1,
      dragAndDrop: !1,
      handler: () => {
      },
      injectMarkup: !0,
      types: ["image/*"]
    },
    hooks: {
      afterUpdate: () => {
      },
      beforeUpdate: () => {
      }
    },
    interface: {
      appearance: V.Auto,
      attribution: !0,
      autocomplete: !1,
      images: !1,
      lists: !1,
      readonly: !1,
      spellcheck: !0,
      toolbar: !1
    },
    placeholder: "",
    plugins: [],
    readability: !1,
    selections: [],
    toolbar: {
      bold: !0,
      code: !0,
      codeBlock: !0,
      heading: !0,
      image: !0,
      italic: !0,
      link: !0,
      list: !0,
      orderedList: !0,
      quote: !0,
      taskList: !0,
      upload: !1
    },
    vim: !1
  };
  return {
    doc: "",
    editor: {},
    extensions: jt(),
    options: e,
    root: xe(),
    target: xe()
  };
}, Vt = (e) => P(oe(), e), ce = (e, t = {}) => {
  const [n, r] = B(Vt({ ...t, doc: e.doc || "", options: e }));
  return [n, r];
}, Ot = ([e]) => {
  const { editor: t } = e();
  t.destroy();
}, ie = ([e]) => {
  const { editor: t } = e();
  t.hasFocus || t.focus();
}, Le = (e) => {
  const t = e.map((n) => lt.fromJSON({ anchor: n.start, head: n.end }));
  return dt.create(t);
}, Me = (e) => e.ranges.map((n) => ({
  end: n.anchor < n.head ? n.head : n.anchor,
  start: n.head < n.anchor ? n.head : n.anchor
})), C = (e) => ({ ...{
  block: !1,
  line: !1,
  multiline: !1,
  nodes: [],
  prefix: "",
  prefixStates: [],
  suffix: ""
}, ...e }), Rt = {
  [k.Bold]: C({
    nodes: ["StrongEmphasis"],
    prefix: "**",
    suffix: "**"
  }),
  [k.Code]: C({
    nodes: ["InlineCode"],
    prefix: "`",
    suffix: "`"
  }),
  [k.CodeBlock]: C({
    block: !0,
    nodes: ["FencedCode"],
    prefix: "```\n",
    suffix: "\n```"
  }),
  [k.Heading]: C({
    multiline: !0,
    nodes: ["ATXHeading1", "ATXHeading2", "ATXHeading3", "ATXHeading4", "ATXHeading5", "ATXHeading6"],
    prefix: "# ",
    prefixStates: ["# ", "## ", "### ", "#### ", "##### ", "###### ", ""]
  }),
  [k.Image]: C({
    nodes: ["Image"],
    prefix: "![](",
    suffix: ")"
  }),
  [k.Italic]: C({
    nodes: ["Emphasis"],
    prefix: "*",
    suffix: "*"
  }),
  [k.Link]: C({
    nodes: ["Link"],
    prefix: "[](",
    suffix: ")"
  }),
  [k.OrderedList]: C({
    line: !0,
    multiline: !0,
    nodes: ["OrderedList"],
    prefix: "1. "
  }),
  [k.Quote]: C({
    line: !0,
    multiline: !0,
    nodes: ["Blockquote"],
    prefix: "> "
  }),
  [k.TaskList]: C({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- [ ] "
  }),
  [k.List]: C({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- "
  })
}, It = ({ editor: e, selection: t }) => {
  let n = t.start;
  const r = [];
  for (; n <= t.end; ) {
    const o = e.lineBlockAt(n), i = Math.max(t.start, o.from), a = Math.min(t.end, o.to);
    r.push({ start: i, end: a }), n = o.to + 1;
  }
  return r;
}, Nt = ({ editor: e, formatDefinition: t, selection: n }) => {
  if (!e || !t)
    return n || { start: 0, end: 0 };
  const r = n || Me(e.state.selection).pop() || { start: 0, end: 0 };
  if (t.block || t.line || t.multiline) {
    const a = e.lineBlockAt(r.start).from, s = e.lineBlockAt(r.end).to;
    return { start: a, end: s };
  }
  const o = e.state.wordAt(r.start)?.from || r.start, i = e.state.wordAt(r.end)?.to || r.end;
  return { start: o, end: i };
}, He = (e) => e.editor.state.sliceDoc(e.selection.start, e.selection.end), qt = (e, t, n) => Pt(e, n).find(({ type: o }) => t.nodes.includes(o.name)), Pt = (e, t) => {
  const n = [];
  return le(e.state).iterate({
    from: t.start,
    to: t.end,
    enter: ({ type: r, from: o, to: i }) => {
      n.push({ type: r, from: o, to: i });
    }
  }), n;
}, ue = (e) => {
  const t = He(e), n = e.formatDefinition.prefix.length, r = e.formatDefinition.suffix.length * -1 || t.length, o = t.slice(n, r);
  return [{ from: e.selection.start, to: e.selection.end, insert: o }];
}, Wt = (e) => {
  if (e.node) {
    const t = e.node.from, n = e.node.to;
    return ue({ ...e, selection: { start: t, end: n } });
  } else {
    const t = e.formatDefinition.prefix, n = e.formatDefinition.suffix;
    return [
      { from: e.selection.start, insert: t },
      { from: e.selection.end, insert: n }
    ];
  }
}, Ft = (e) => {
  const t = It(e), n = [];
  return t.forEach((r) => {
    const o = Ae({ ...e, selection: r });
    n.push(...o);
  }), n;
}, Ae = (e) => {
  const t = e.formatDefinition.prefixStates.length > 0, n = He(e);
  if (e.node && t) {
    const r = e.formatDefinition.prefixStates.find((o) => n.startsWith(o));
    if (r) {
      const o = e.formatDefinition.prefixStates.indexOf(r), i = e.formatDefinition.prefixStates[o + 1], a = n.replace(new RegExp(`^${r}`), i);
      return [{ from: e.selection.start, to: e.selection.end, insert: a }];
    }
  } else if (e.node && n.startsWith(e.formatDefinition.prefix))
    return ue(e);
  return [{ from: e.selection.start, insert: e.formatDefinition.prefix }];
}, Ut = (e) => {
  if (e.node) {
    const t = e.node.from, n = e.node.to;
    return ue({ ...e, selection: { start: t, end: n } });
  } else {
    const { formatDefinition: t, selection: n } = e, r = Array.isArray(t.prefix) ? t.prefix[0] : t.prefix, o = t.suffix;
    return [
      { from: n.start, insert: r },
      { from: n.end, insert: o }
    ];
  }
}, Xt = (e) => e.formatDefinition.block ? Wt(e) : e.formatDefinition.multiline ? Ft(e) : e.formatDefinition.line ? Ae(e) : Ut(e), ze = ([e], t, { selection: n } = {}) => {
  const { editor: r } = e(), o = Rt[t], i = Nt({ editor: r, formatDefinition: o, selection: n }), a = qt(r, o, i), d = Xt({
    editor: r,
    formatDefinition: o,
    node: a,
    selection: i
  }), u = d.reduce(($, y) => {
    const w = y.insert.length - ((y.to || y.from) - y.from);
    return $ + w;
  }, 0), h = e().editor.state.update({ changes: d, selection: { head: i.start, anchor: i.end + u } });
  e().editor.dispatch(h);
}, Kt = ([e]) => {
  const { editor: t } = e();
  return t.state.sliceDoc();
}, fe = ([e]) => {
  const { editor: t } = e();
  return Me(t.state.selection);
}, Z = ([e, t], n, r, o = !1) => {
  const { editor: i } = e();
  let a = r?.start, s = r?.end || r?.start;
  if (typeof a > "u") {
    const u = fe([e, t]).pop();
    a = u.start, s = u.end;
  }
  const d = { changes: { from: a, to: s, insert: n } };
  if (o) {
    const u = a === s ? a + n.length : a, h = a + n.length;
    Object.assign(d, { selection: { anchor: u, head: h } });
  }
  i.dispatch(
    i.state.update(d)
  );
}, Qt = [
  "Blockquote"
], Yt = L.line({ attributes: { class: "cm-blockquote" } }), Zt = L.line({ attributes: { class: "cm-blockquote-open" } }), Gt = L.line({ attributes: { class: "cm-blockquote-close" } }), Jt = Ce.define((e) => ({
  update: () => en(e)
}), { decorations: (e) => e.update() }), en = (e) => {
  const t = new _e(), n = le(e.state);
  for (const r of e.visibleRanges)
    for (let o = r.from; o < r.to; ) {
      const i = e.state.doc.lineAt(o);
      n.iterate({
        enter({ type: a, from: s, to: d }) {
          if (a.name !== "Document" && Qt.includes(a.name)) {
            t.add(i.from, i.from, Yt);
            const u = e.state.doc.lineAt(s), h = e.state.doc.lineAt(d);
            return u.number === i.number && t.add(i.from, i.from, Zt), h.number === i.number && t.add(i.from, i.from, Gt), !1;
          }
        },
        from: i.from,
        to: i.to
      }), o = i.to + 1;
    }
  return t.finish();
}, tn = () => [
  Jt
], nn = [
  "CodeBlock",
  "FencedCode",
  "HTMLBlock",
  "CommentBlock"
], O = {
  // Prevent spellcheck in all code blocks. The Grammarly extension might not respect these values.
  "data-enable-grammarly": "false",
  "data-gramm": "false",
  "data-grammarly-skip": "true",
  spellcheck: "false"
}, rn = L.line({ attributes: { ...O, class: "cm-codeblock" } }), on = L.line({ attributes: { ...O, class: "cm-codeblock-open" } }), an = L.line({ attributes: { ...O, class: "cm-codeblock-close" } }), sn = L.mark({ attributes: { ...O, class: "cm-code" } }), ln = L.mark({ attributes: { ...O, class: "cm-code cm-code-open" } }), dn = L.mark({ attributes: { ...O, class: "cm-code cm-code-close" } }), cn = Ce.define((e) => ({
  update: () => un(e)
}), { decorations: (e) => e.update() }), un = (e) => {
  const t = new _e(), n = le(e.state);
  for (const r of e.visibleRanges)
    for (let o = r.from; o < r.to; ) {
      const i = e.state.doc.lineAt(o);
      let a;
      n.iterate({
        enter({ type: s, from: d, to: u }) {
          if (s.name !== "Document")
            if (nn.includes(s.name)) {
              t.add(i.from, i.from, rn);
              const h = e.state.doc.lineAt(d), $ = e.state.doc.lineAt(u);
              return h.number === i.number && t.add(i.from, i.from, on), $.number === i.number && t.add(i.from, i.from, an), !1;
            } else
              s.name === "InlineCode" ? a = { from: d, to: u, innerFrom: d, innerTo: u } : s.name === "CodeMark" && (d === a.from ? (a.innerFrom = u, t.add(d, u, ln)) : u === a.to && (a.innerTo = d, t.add(a.innerFrom, a.innerTo, sn), t.add(d, u, dn)));
        },
        from: i.from,
        to: i.to
      }), o = i.to + 1;
    }
  return t.finish();
}, fn = () => [
  cn
], mn = () => [
  q.editorAttributes.of({
    class: "ink-mde-container"
  }),
  q.contentAttributes.of({
    class: "ink-mde-editor-content"
  })
  // Todo: Maybe open a PR to add scrollerAttributes?
], pn = () => [
  ...mn()
], gn = [
  {
    key: "Tab",
    run: ({ state: e, dispatch: t }) => e.selection.ranges.some((n) => !n.empty) ? vt({ state: e, dispatch: t }) : (t(
      e.update(e.replaceSelection("  "), {
        scrollIntoView: !0,
        annotations: ct.userEvent.of("input")
      })
    ), !0),
    shift: yt
  }
], kn = () => gt.of([
  ...gn,
  ...bt,
  ...xt
]), hn = () => q.lineWrapping, bn = () => [
  kt(
    ht.define([
      // ordered by lowest to highest precedence
      {
        tag: c.atom,
        color: "var(--ink-internal-syntax-atom-color)"
      },
      {
        tag: c.meta,
        color: "var(--ink-internal-syntax-meta-color)"
      },
      // emphasis types
      {
        tag: c.emphasis,
        color: "var(--ink-internal-syntax-emphasis-color)",
        fontStyle: "var(--ink-internal-syntax-emphasis-font-style)"
      },
      {
        tag: c.strong,
        color: "var(--ink-internal-syntax-strong-color)",
        fontWeight: "var(--ink-internal-syntax-strong-font-weight)"
      },
      {
        tag: c.strikethrough,
        color: "var(--ink-internal-syntax-strikethrough-color)",
        textDecoration: "var(--ink-internal-syntax-strikethrough-text-decoration)"
      },
      // comment group
      {
        tag: c.comment,
        color: "var(--ink-internal-syntax-comment-color)",
        fontStyle: "var(--ink-internal-syntax-comment-font-style)"
      },
      // monospace
      {
        tag: c.monospace,
        color: "var(--ink-internal-syntax-code-color)",
        fontFamily: "var(--ink-internal-syntax-code-font-family)"
      },
      // name group
      {
        tag: c.name,
        color: "var(--ink-internal-syntax-name-color)"
      },
      {
        tag: c.labelName,
        color: "var(--ink-internal-syntax-name-label-color)"
      },
      {
        tag: c.propertyName,
        color: "var(--ink-internal-syntax-name-property-color)"
      },
      {
        tag: c.definition(c.propertyName),
        color: "var(--ink-internal-syntax-name-property-definition-color)"
      },
      {
        tag: c.variableName,
        color: "var(--ink-internal-syntax-name-variable-color)"
      },
      {
        tag: c.definition(c.variableName),
        color: "var(--ink-internal-syntax-name-variable-definition-color)"
      },
      {
        tag: c.local(c.variableName),
        color: "var(--ink-internal-syntax-name-variable-local-color)"
      },
      {
        tag: c.special(c.variableName),
        color: "var(--ink-internal-syntax-name-variable-special-color)"
      },
      // headings
      {
        tag: c.heading,
        color: "var(--ink-internal-syntax-heading-color)",
        fontWeight: "var(--ink-internal-syntax-heading-font-weight)"
      },
      {
        tag: c.heading1,
        color: "var(--ink-internal-syntax-heading1-color)",
        fontSize: "var(--ink-internal-syntax-heading1-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading1-font-weight)"
      },
      {
        tag: c.heading2,
        color: "var(--ink-internal-syntax-heading2-color)",
        fontSize: "var(--ink-internal-syntax-heading2-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading2-font-weight)"
      },
      {
        tag: c.heading3,
        color: "var(--ink-internal-syntax-heading3-color)",
        fontSize: "var(--ink-internal-syntax-heading3-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading3-font-weight)"
      },
      {
        tag: c.heading4,
        color: "var(--ink-internal-syntax-heading4-color)",
        fontSize: "var(--ink-internal-syntax-heading4-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading4-font-weight)"
      },
      {
        tag: c.heading5,
        color: "var(--ink-internal-syntax-heading5-color)",
        fontSize: "var(--ink-internal-syntax-heading5-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading5-font-weight)"
      },
      {
        tag: c.heading6,
        color: "var(--ink-internal-syntax-heading6-color)",
        fontSize: "var(--ink-internal-syntax-heading6-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading6-font-weight)"
      },
      // contextual tag types
      {
        tag: c.keyword,
        color: "var(--ink-internal-syntax-keyword-color)"
      },
      {
        tag: c.number,
        color: "var(--ink-internal-syntax-number-color)"
      },
      {
        tag: c.operator,
        color: "var(--ink-internal-syntax-operator-color)"
      },
      {
        tag: c.punctuation,
        color: "var(--ink-internal-syntax-punctuation-color)"
      },
      {
        tag: c.link,
        color: "var(--ink-internal-syntax-link-color)"
      },
      {
        tag: c.url,
        color: "var(--ink-internal-syntax-url-color)"
      },
      // string group
      {
        tag: c.string,
        color: "var(--ink-internal-syntax-string-color)"
      },
      {
        tag: c.special(c.string),
        color: "var(--ink-internal-syntax-string-special-color)"
      },
      // processing instructions
      {
        tag: c.processingInstruction,
        color: "var(--ink-internal-syntax-processing-instruction-color)"
      }
    ])
  )
], xn = (e) => {
  if (e.length > 0)
    return Le(e);
}, Ee = (e) => ut.create({
  doc: e.options.doc,
  selection: xn(e.options.selections),
  extensions: [
    tn(),
    fn(),
    $t(),
    pn(),
    kn(),
    hn(),
    bn(),
    ...zt(e)
  ]
}), vn = ([e, t], n) => {
  t(P(e(), { options: { doc: n } })), e().editor.setState(Ee(e()));
}, yn = ([e]) => e().options, $n = async ([e, t], n) => {
  const r = t(P(e(), { options: n })), o = await de(r);
  r.editor.dispatch({ effects: o });
}, Be = (e, t = {}) => {
  if (t.selections)
    return je(e, t.selections);
  if (t.selection)
    return ae(e, t.selection);
  if (t.at)
    return wn(e, t.at);
}, wn = (e, t) => {
  const [n] = e;
  if (t === re.Start)
    return ae(e, { start: 0, end: 0 });
  if (t === re.End) {
    const r = n().editor.state.doc.length;
    return ae(e, { start: r, end: r });
  }
}, je = ([e], t) => {
  const { editor: n } = e();
  n.dispatch(
    n.state.update({
      selection: Le(t)
    })
  );
}, ae = (e, t) => je(e, [t]), _n = ([e], t) => {
  const { editor: n } = e();
  n.dispatch(
    n.state.update({
      changes: {
        from: 0,
        to: n.state.doc.length,
        insert: t
      }
    })
  );
}, Cn = ([e, t], { after: n, before: r, selection: o }) => {
  const { editor: i } = e(), a = o || fe([e, t]).pop() || { start: 0, end: 0 }, s = i.state.sliceDoc(a.start, a.end);
  Z([e, t], `${r}${s}${n}`, a), Be([e, t], { selections: [{ start: a.start + r.length, end: a.end + r.length }] });
}, De = (e) => ({
  destroy: Ot.bind(void 0, e),
  focus: ie.bind(void 0, e),
  format: ze.bind(void 0, e),
  getDoc: Kt.bind(void 0, e),
  insert: Z.bind(void 0, e),
  load: vn.bind(void 0, e),
  options: yn.bind(void 0, e),
  reconfigure: $n.bind(void 0, e),
  select: Be.bind(void 0, e),
  selections: fe.bind(void 0, e),
  update: _n.bind(void 0, e),
  wrap: Cn.bind(void 0, e)
}), Sn = `.ink-drop-zone{align-items:center;background-color:#00000080;color:var(--ink-internal-color);display:flex;inset:0;justify-content:center;position:var(--ink-internal-modal-position);z-index:100}.ink-drop-zone:not(.visible){display:none}.ink-drop-zone-modal{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);box-sizing:border-box;height:100%;max-height:20rem;max-width:40rem;padding:1rem;position:relative;width:100%}.ink-drop-zone-hide{cursor:pointer;height:1.75rem;position:absolute;right:.25rem;top:.25rem;width:1.75rem}.ink-drop-zone-hide svg{background-color:var(--ink-internal-block-background-color)}.ink-drop-zone-droppable-area{align-items:center;border:.2rem dashed var(--ink-internal-color);border-radius:.125rem;box-sizing:border-box;display:flex;flex-direction:column;font-size:1.25em;gap:1rem;height:100%;justify-content:center;padding:1rem;text-align:center}.ink-drop-zone-file-preview{align-items:center;display:flex;flex-wrap:wrap;gap:.5rem;max-width:25.5rem}.ink-drop-zone-file-preview-image{border:.125rem solid #222;border-radius:.125rem;box-sizing:border-box;height:6rem;object-fit:cover;padding:.5rem;width:6rem}
`, Ln = /* @__PURE__ */ m("<span>uploading files...</span>", 2), Mn = /* @__PURE__ */ m('<div class="ink-drop-zone"><style></style><div class="ink-drop-zone-modal"><div class="ink-drop-zone-droppable-area"><div class="ink-drop-zone-file-preview"></div><!#><!/></div><div class="ink-drop-zone-hide"><svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M10 14l2-2m0 0l2-2m-2 2l-2-2m2 2l2 2m7-2a9 9 0 11-18 0 9 9 0 0118 0z"></path></svg></div></div></div>', 18), Hn = /* @__PURE__ */ m('<img class="ink-drop-zone-file-preview-image">', 1), An = /* @__PURE__ */ m("<span>drop files here</span>", 2), zn = () => {
  const [e, t] = B(0), [n, r] = B([]), [o, i] = B(!1), [a, s] = B(!1), [d, u] = R(), h = () => {
    s(!1);
  }, $ = (g) => {
    if (d().options.files.dragAndDrop) {
      g.preventDefault(), g.stopPropagation();
      const v = g.dataTransfer;
      v?.files ? W(v.files) : (t(0), s(!1), r([]));
    }
  }, y = (g) => {
    d().options.files.dragAndDrop && (g.preventDefault(), t(e() + 1), s(!0));
  }, w = (g) => {
    d().options.files.dragAndDrop && (g.preventDefault(), t(e() - 1), e() === 0 && s(!1));
  }, M = (g) => {
    d().options.files.dragAndDrop && (g.preventDefault(), s(!0));
  }, A = (g) => {
    d().options.files.dragAndDrop && (g.preventDefault(), t(0), s(!1));
  }, j = (g) => {
    if (d().options.files.clipboard) {
      g.preventDefault();
      const v = g.clipboardData;
      v?.files && v.files.length > 0 && W(v.files);
    }
  }, W = (g) => {
    Array.from(g).forEach((v) => {
      r([...n(), v]);
    }), i(!0), s(!0), Promise.resolve(d().options.files.handler(g)).then((v) => {
      if (d().options.files.injectMarkup && v) {
        const S = `![](${v})`;
        Z([d, u], S);
      }
    }).finally(() => {
      t(0), i(!1), s(!1), r([]);
    });
  };
  return $e(() => {
    document.addEventListener("dragenter", y), document.addEventListener("dragleave", w), document.addEventListener("dragover", M), document.addEventListener("drop", A), d().root.addEventListener("paste", j);
  }), rt(() => {
    document.removeEventListener("dragenter", y), document.removeEventListener("dragleave", w), document.removeEventListener("dragover", M), document.removeEventListener("drop", A), d().root.removeEventListener("paste", j);
  }), (() => {
    const g = f(Mn), v = g.firstChild, S = v.nextSibling, D = S.firstChild, I = D.firstChild, G = I.nextSibling, [J, F] = b(G.nextSibling), ee = D.nextSibling;
    return v.textContent = Sn, D.addEventListener("drop", $), p(I, l(ot, {
      get each() {
        return n().slice(0, 8);
      },
      children: (U) => (() => {
        const N = f(Hn);
        return ne((z) => {
          const H = U.name, X = URL.createObjectURL(U);
          return H !== z._v$ && be(N, "alt", z._v$ = H), X !== z._v$2 && be(N, "src", z._v$2 = X), z;
        }, {
          _v$: void 0,
          _v$2: void 0
        }), N;
      })()
    })), p(D, l(x, {
      get when() {
        return o();
      },
      get fallback() {
        return f(An);
      },
      get children() {
        return f(Ln);
      }
    }), J, F), ee.$$click = h, ne(() => g.classList.toggle("visible", !!a())), se(), g;
  })();
};
ve(["click"]);
const En = ([e, t]) => {
  const n = new q({
    dispatch: (r) => {
      const { options: o } = e(), i = r.newDoc.toString();
      o.hooks.beforeUpdate(i), n.update([r]), r.docChanged && (t({ ...e(), doc: i }), o.hooks.afterUpdate(i));
    },
    state: Ee(e())
  });
  return n;
}, Bn = () => {
  const [e, t] = R(), n = En([e, t]);
  return t(P(e(), {
    editor: n
  })), de(e()).then((r) => {
    n.dispatch({
      effects: r
    });
  }), n.dom;
}, jn = /* @__PURE__ */ m('<button class="ink-button" type="button"></button>', 2), _ = (e) => (() => {
  const t = f(jn);
  return t.$$click = (n) => e.onclick(n), p(t, () => e.children), se(), t;
})();
ve(["click"]);
const Dn = `.ink-mde .ink-mde-toolbar{background-color:var(--ink-internal-block-background-color);color:inherit;display:flex;flex-shrink:0;overflow-x:auto;padding:.25rem}.ink-mde .ink-mde-toolbar .ink-mde-container{display:flex;gap:2rem}.ink-mde .ink-mde-toolbar-group{display:flex}.ink-mde .ink-mde-toolbar .ink-button{align-items:center;background:none;border:none;border-radius:var(--ink-internal-border-radius);color:inherit;cursor:pointer;display:flex;height:2.25rem;justify-content:center;padding:.4rem;width:2.25rem}.ink-mde .ink-mde-toolbar .ink-button:hover{background-color:var(--ink-internal-block-background-color-on-hover)}.ink-mde .ink-mde-toolbar .ink-button>*{align-items:center;display:flex;height:100%}
`, Tn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6 4V10M6 16V10M6 10H14M14 10V4M14 10V16"></path></svg>', 4), Vn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-width="1.5" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6.5 10H10.5C12.1569 10 13.5 11.3431 13.5 13C13.5 14.6569 12.1569 16 10.5 16H6.5V4H9.5C11.1569 4 12.5 5.34315 12.5 7C12.5 8.65686 11.1569 10 9.5 10"></path></svg>', 4), On = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M11 4L9 16M13 4H9M7 16H11"></path></svg>', 4), Rn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M2.00257 16H17.9955M2.00055 4H18M7 10H18.0659M2 8.5V11.4999C2.4 11.5 2.5 11.5 2.5 11.5V11V10.5M4 8.5V11.4999H4.5V11V10.5"></path></svg>', 4), In = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M13 4L7 16"></path><path d="M5 7L2 10L5 13"></path><path d="M15 7L18 10L15 13"></path></svg>', 8), Nn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 4L8 6"></path></svg>', 4), qn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M2 16H4"></path><path d="M7 10H17.8294"></path><path d="M2 10H4"></path><path d="M7 4H17.8294"></path><path d="M2 4H4"></path></svg>', 14), Pn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H18"></path><path d="M2 17.0242C2.48314 17.7569 3.94052 17.6154 3.99486 16.7919C4.05315 15.9169 3.1975 16.0044 2.99496 16.0044M2.0023 14.9758C2.48544 14.2431 3.94282 14.3846 3.99716 15.2081C4.05545 16.0831 3.1998 16.0002 2.99726 16.0002"></path><path d="M7 10H18"></path><path d="M2.00501 11.5H4M2.00193 8.97562C2.48449 8.24319 3.9401 8.38467 3.99437 9.20777C4.05259 10.0825 2.04342 10.5788 2 11.4996"></path><path d="M7 4H18"></path><path d="M2 5.5H4M2.99713 5.49952V2.5L2.215 2.93501"></path></svg>', 14), Wn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M5 15L3 17L2 16"></path><path d="M7 10H17.8294"></path><path d="M5 9L3 11L2 10"></path><path d="M7 4H17.8294"></path><path d="M5 3L3 5L2 4"></path></svg>', 14), Fn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M9.12127 10.881C10.02 11.78 11.5237 11.7349 12.4771 10.7813L15.2546 8.00302C16.2079 7.04937 16.253 5.54521 15.3542 4.6462C14.4555 3.74719 12.9512 3.79174 11.9979 4.74539L10.3437 6.40007M10.8787 9.11903C9.97997 8.22002 8.47626 8.26509 7.52288 9.21874L4.74545 11.997C3.79208 12.9506 3.74701 14.4548 4.64577 15.3538C5.54452 16.2528 7.04876 16.2083 8.00213 15.2546L9.65633 13.5999"></path></svg>', 4), Un = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><rect x="2" y="4" width="16" height="12" rx="1"></rect><path d="M7.42659 7.67597L13.7751 13.8831M2.00208 12.9778L7.42844 7.67175"></path><path d="M11.9119 12.0599L14.484 9.54443L17.9973 12.9785"></path><path d="M10.9989 7.95832C11.551 7.95832 11.9986 7.52072 11.9986 6.98092C11.9986 6.44113 11.551 6.00354 10.9989 6.00354C10.4468 6.00354 9.99921 6.44113 9.99921 6.98092C9.99921 7.52072 10.4468 7.95832 10.9989 7.95832Z"></path></svg>', 10), Xn = /* @__PURE__ */ m('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M10 13V4M10 4L13 7M10 4L7 7"></path><path d="M2 13V15C2 15.5523 2.44772 16 3 16H17C17.5523 16 18 15.5523 18 15V13"></path></svg>', 6), Kn = /* @__PURE__ */ m('<input type="file">', 1), Qn = /* @__PURE__ */ m('<div class="ink-mde-toolbar"><style></style><div class="ink-mde-container"><div class="ink-mde-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-mde-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-mde-toolbar-group"><!#><!/><!#><!/><!#><!/></div><div class="ink-mde-toolbar-group"><!#><!/><!#><!/><!#><!/></div></div></div>', 38), Yn = () => {
  const [e, t] = R(), [n, r] = B(), o = (s) => {
    ze([e, t], s), ie([e, t]);
  }, i = (s) => {
    const d = s.target;
    d?.files && Promise.resolve(e().options.files.handler(d.files)).then((u) => {
      const h = `![](${u})`;
      Z([e, t], h), ie([e, t]);
    });
  }, a = () => {
    n()?.click();
  };
  return (() => {
    const s = f(Qn), d = s.firstChild, u = d.nextSibling, h = u.firstChild, $ = h.firstChild, [y, w] = b($.nextSibling), M = y.nextSibling, [A, j] = b(M.nextSibling), W = A.nextSibling, [g, v] = b(W.nextSibling), S = h.nextSibling, D = S.firstChild, [I, G] = b(D.nextSibling), J = I.nextSibling, [F, ee] = b(J.nextSibling), U = F.nextSibling, [N, z] = b(U.nextSibling), H = S.nextSibling, X = H.firstChild, [pe, Re] = b(X.nextSibling), Ie = pe.nextSibling, [ge, Ne] = b(Ie.nextSibling), qe = ge.nextSibling, [Pe, We] = b(qe.nextSibling), K = H.nextSibling, Fe = K.firstChild, [ke, Ue] = b(Fe.nextSibling), Xe = ke.nextSibling, [he, Ke] = b(Xe.nextSibling), Qe = he.nextSibling, [Ye, Ze] = b(Qe.nextSibling);
    return d.textContent = Dn, p(h, l(x, {
      get when() {
        return e().options.toolbar.heading;
      },
      get children() {
        return l(_, {
          onclick: () => o(k.Heading),
          get children() {
            return f(Tn);
          }
        });
      }
    }), y, w), p(h, l(x, {
      get when() {
        return e().options.toolbar.bold;
      },
      get children() {
        return l(_, {
          onclick: () => o(k.Bold),
          get children() {
            return f(Vn);
          }
        });
      }
    }), A, j), p(h, l(x, {
      get when() {
        return e().options.toolbar.italic;
      },
      get children() {
        return l(_, {
          onclick: () => o(k.Italic),
          get children() {
            return f(On);
          }
        });
      }
    }), g, v), p(S, l(x, {
      get when() {
        return e().options.toolbar.quote;
      },
      get children() {
        return l(_, {
          onclick: () => o(k.Quote),
          get children() {
            return f(Rn);
          }
        });
      }
    }), I, G), p(S, l(x, {
      get when() {
        return e().options.toolbar.codeBlock;
      },
      get children() {
        return l(_, {
          onclick: () => o(k.CodeBlock),
          get children() {
            return f(In);
          }
        });
      }
    }), F, ee), p(S, l(x, {
      get when() {
        return e().options.toolbar.code;
      },
      get children() {
        return l(_, {
          onclick: () => o(k.Code),
          get children() {
            return f(Nn);
          }
        });
      }
    }), N, z), p(H, l(x, {
      get when() {
        return e().options.toolbar.list;
      },
      get children() {
        return l(_, {
          onclick: () => o(k.List),
          get children() {
            return f(qn);
          }
        });
      }
    }), pe, Re), p(H, l(x, {
      get when() {
        return e().options.toolbar.orderedList;
      },
      get children() {
        return l(_, {
          onclick: () => o(k.OrderedList),
          get children() {
            return f(Pn);
          }
        });
      }
    }), ge, Ne), p(H, l(x, {
      get when() {
        return e().options.toolbar.taskList;
      },
      get children() {
        return l(_, {
          onclick: () => o(k.TaskList),
          get children() {
            return f(Wn);
          }
        });
      }
    }), Pe, We), p(K, l(x, {
      get when() {
        return e().options.toolbar.link;
      },
      get children() {
        return l(_, {
          onclick: () => o(k.Link),
          get children() {
            return f(Fn);
          }
        });
      }
    }), ke, Ue), p(K, l(x, {
      get when() {
        return e().options.toolbar.image;
      },
      get children() {
        return l(_, {
          onclick: () => o(k.Image),
          get children() {
            return f(Un);
          }
        });
      }
    }), he, Ke), p(K, l(x, {
      get when() {
        return e().options.toolbar.upload;
      },
      get children() {
        return l(_, {
          onclick: a,
          get children() {
            return [f(Xn), (() => {
              const Q = f(Kn);
              return ye(r, Q), Q.addEventListener("change", i), Q.style.setProperty("display", "none"), Q;
            })()];
          }
        });
      }
    }), Ye, Ze), s;
  })();
}, me = 225, Zn = (e, t = me) => {
  const n = er(e, t), r = tr(e), o = Jn(e), i = Gn(e);
  return [n, r, o, i].join(" | ");
}, Gn = (e) => `${nr(e)} chars`, Jn = (e) => `${rr(e)} lines`, er = (e, t = me) => {
  const n = or(e, t), r = Math.floor(n), o = Math.floor(n % 1 * 60);
  return r === 0 ? `${o}s read` : `${r}m ${o}s to read`;
}, tr = (e) => `${Te(e)} words`, nr = (e) => e.length, rr = (e) => e.split(/\n/).length, or = (e, t = me) => Te(e) / t, Te = (e) => {
  const t = e.replace(/[']/g, "").replace(/[^\w\d]+/g, " ").trim();
  return t ? t.split(/\s+/).length : 0;
}, ir = /* @__PURE__ */ m('<div class="ink-mde-readability"><span></span></div>', 4), ar = /* @__PURE__ */ m("<span>&nbsp;|</span>", 2), sr = /* @__PURE__ */ m('<div class="ink-mde-attribution"><span>&nbsp;powered by <a class="ink-mde-attribution-link" href="https://github.com/voracious/ink-mde" rel="noopener noreferrer" target="_blank">ink-mde</a></span></div>', 6), lr = /* @__PURE__ */ m('<div class="ink-mde-details"><div class="ink-mde-container"><div class="ink-mde-details-content"><!#><!/><!#><!/><!#><!/></div></div></div>', 12), dr = () => {
  const [e] = R();
  return (() => {
    const t = f(lr), n = t.firstChild, r = n.firstChild, o = r.firstChild, [i, a] = b(o.nextSibling), s = i.nextSibling, [d, u] = b(s.nextSibling), h = d.nextSibling, [$, y] = b(h.nextSibling);
    return p(r, l(x, {
      get when() {
        return e().options.readability;
      },
      get children() {
        const w = f(ir), M = w.firstChild;
        return p(M, () => Zn(e().doc)), w;
      }
    }), i, a), p(r, l(x, {
      get when() {
        return Ge(() => !!e().options.readability)() && e().options.interface.attribution;
      },
      get children() {
        return f(ar);
      }
    }), d, u), p(r, l(x, {
      get when() {
        return e().options.interface.attribution;
      },
      get children() {
        return f(sr);
      }
    }), $, y), t;
  })();
}, cr = `.ink-mde{border:2px solid var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);color:var(--ink-internal-color, inherit);display:flex;flex-direction:var(--ink-internal-flex-direction, column)}.ink-mde .cm-tooltip{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);font-family:inherit;padding:.25rem}.ink-mde .cm-tooltip.cm-tooltip-autocomplete ul{font-family:inherit}.ink-mde .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option{border-radius:var(--ink-internal-border-radius);padding:.25rem}.ink-mde .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option[aria-selected]{background-color:#96969640}.ink-mde .cm-completionLabel{font-family:inherit}.ink-mde,.ink-mde *{box-sizing:border-box}.ink-mde,.ink-mde .ink-mde-editor{display:flex;flex-direction:column;flex-grow:1;flex-shrink:1;min-height:0}.ink-mde .ink-mde-editor{overflow:auto;padding:.5rem}.ink-mde .ink-mde-toolbar,.ink-mde .ink-mde-details{display:flex;flex-grow:0;flex-shrink:0}.ink-mde .ink-mde-details{background-color:var(--ink-internal-block-background-color);display:flex;padding:.5rem}.ink-mde .ink-mde-details-content{color:inherit;display:flex;filter:brightness(.75);flex-wrap:wrap;font-size:.75em;justify-content:flex-end}.ink-mde .ink-mde-attribution{display:flex;justify-content:flex-end}.ink-mde .ink-mde-attribution-link{color:currentColor;font-weight:600;text-decoration:none}.ink-mde .ink-mde-container{margin-left:auto;margin-right:auto;width:100%}.ink-mde .ink-mde-task-toggle{cursor:pointer;height:1rem;line-height:2em;margin:0 .25rem 0 0;position:relative;top:-1px;vertical-align:middle;width:1rem}.ink-mde .cm-editor{display:flex;flex-direction:column;position:relative}.ink-mde .cm-scroller{align-items:flex-start;display:flex;font-family:var(--ink-internal-font-family);font-size:var(--ink-internal-editor-font-size);line-height:var(--ink-internal-editor-line-height);overflow-x:auto;position:relative}.ink-mde .cm-content{display:block;flex-grow:2;flex-shrink:0;margin:0;outline:none;padding:0;white-space:pre;word-wrap:normal}.ink-mde .cm-lineWrapping{flex-shrink:1;overflow-wrap:anywhere;white-space:break-spaces;word-break:break-word}.ink-mde .cm-line{font-family:var(--ink-internal-font-family);padding:0}.ink-mde .cm-line.cm-blockquote{background-color:var(--ink-internal-block-background-color);border-left:.25rem solid currentColor;padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-blockquote.cm-blockquote-open{border-top-left-radius:var(--ink-internal-border-radius);border-top-right-radius:var(--ink-internal-border-radius);padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-blockquote.cm-blockquote-close{border-bottom-left-radius:var(--ink-internal-border-radius);border-bottom-right-radius:var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-open{border-radius:var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0 0;padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-close{border-radius:0 0 var(--ink-internal-border-radius) var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line .cm-code{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:var(--ink-internal-inline-padding) 0}.ink-mde .cm-line .cm-code.cm-code-open{border-radius:var(--ink-internal-border-radius) 0 0 var(--ink-internal-border-radius);padding-left:var(--ink-internal-inline-padding)}.ink-mde .cm-line .cm-code.cm-code-close{border-radius:0 var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0;padding-right:var(--ink-internal-inline-padding)}.ink-mde .cm-image-backdrop{background-color:var(--ink-internal-block-background-color)}
`, ur = /* @__PURE__ */ m("<style> </style>", 2), fr = () => {
  const [e] = R(), [t, n] = B(te(e()));
  return it(() => {
    n(te(e()));
  }), $e(() => {
    const r = window.matchMedia("(prefers-color-scheme: dark)"), o = (i) => {
      const {
        editor: a,
        root: s
      } = e();
      s.isConnected ? de(e()).then((d) => {
        a.dispatch({
          effects: d
        }), n(te(e()));
      }) : r.removeEventListener("change", o);
    };
    r.addEventListener("change", o);
  }), (() => {
    const r = f(ur), o = r.firstChild;
    return ne(() => o.data = `.ink {
  ${t().join(`
  `)}
}
${cr}`), r;
  })();
}, mr = /* @__PURE__ */ m('<div class="ink ink-mde"><!#><!/><!#><!/><!#><!/><div class="ink-mde-editor"></div><!#><!/></div>', 12), pr = () => {
  const [e, t] = R(), n = (r) => {
    t(P(e(), {
      root: r
    }));
  };
  return (() => {
    const r = f(mr), o = r.firstChild, [i, a] = b(o.nextSibling), s = i.nextSibling, [d, u] = b(s.nextSibling), h = d.nextSibling, [$, y] = b(h.nextSibling), w = $.nextSibling, M = w.nextSibling, [A, j] = b(M.nextSibling);
    return ye(n, r), Je(r, et(Ct), !1, !0), p(r, l(fr, {}), i, a), p(r, l(x, {
      get when() {
        return e().options.files.clipboard || e().options.files.dragAndDrop;
      },
      get children() {
        return l(zn, {});
      }
    }), d, u), p(r, l(x, {
      get when() {
        return e().options.interface.toolbar;
      },
      get children() {
        return l(Yn, {});
      }
    }), $, y), p(w, l(Bn, {})), p(r, l(x, {
      get when() {
        return e().options.readability || e().options.interface.attribution;
      },
      get children() {
        return l(dr, {
          store: [e, t]
        });
      }
    }), A, j), se(), r;
  })();
}, Ve = at([() => oe(), (e) => typeof e == "function" ? e(oe()) : e]), gr = (e) => l(Ve.Provider, {
  get value() {
    return e.store;
  },
  get children() {
    return e.children;
  }
}), R = () => st(Ve), Oe = (e) => l(gr, {
  get store() {
    return e.store;
  },
  get children() {
    return l(pr, {
      get store() {
        return e.store;
      }
    });
  }
}), Mr = (e) => e, kr = (e, t = {}) => {
  const n = ce(t);
  return br(), tt(() => l(Oe, {
    store: n
  }), e), De(n);
}, Hr = (e, t = {}) => e.querySelector(_t) ? kr(e, t) : hr(e, t), hr = (e, t = {}) => {
  const n = ce(t);
  return nt(() => l(Oe, {
    store: n
  }), e), De(n);
}, Ar = (e = {}) => (ce(e), ""), br = () => {
  let e, t;
  e = window._$HY || (window._$HY = {
    events: [],
    completed: /* @__PURE__ */ new WeakSet(),
    r: {}
  }), t = (n) => n && n.hasAttribute && (n.hasAttribute("data-hk") ? n : t(n.host && n.host instanceof Node ? n.host : n.parentNode)), ["click", "input"].forEach((n) => document.addEventListener(n, (r) => {
    let o = r.composedPath && r.composedPath()[0] || r.target, i = t(o);
    i && !e.completed.has(i) && e.events.push([i, r]);
  })), e.init = (n, r) => {
    e.r[n] = [new Promise((o, i) => r = o), r];
  }, e.set = (n, r, o) => {
    (o = e.r[n]) && o[1](r), e.r[n] = [r];
  }, e.unset = (n) => {
    delete e.r[n];
  }, e.load = (n, r) => {
    if (r = e.r[n])
      return r[0];
  };
};
export {
  V as Appearance,
  Mt as Extensions,
  k as Markup,
  Y as PluginType,
  re as Selection,
  Hr as default,
  Mr as defineOptions,
  kr as hydrate,
  Hr as ink,
  hr as render,
  Ar as renderToString,
  br as solidPrepareForHydration
};
//# sourceMappingURL=client.js.map
